/*
    Copyright (C) 1999 Paul Barton-Davis 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    $Id: configuration.h,v 1.25 2000/11/03 04:25:18 pbd Exp $
*/

#ifndef __ardour_configuration_h__
#define __ardour_configuration_h__

#include <sys/types.h>
#include <string>
#include <guileconfig/guileconfig.h>

class Configuration : public guileconfig {
  public:
	guileconfig::AudioDeviceRequest audio_device;
	guileconfig::MidiDeviceRequest  midi_device;
	bool   use_real_time;
	int    real_time_priority;
	string pixmap_path;
	string rec_enable_pix_regexp;
	string monitor_pix_regexp;
	string toggle_button_pix_regexp;
	string push_button_pix_regexp;
	string small_push_button_pix_regexp;
	string tape_button_image;
	string play_button_image;
	string forward_button_image;
	string reverse_button_image;
	string record_button_image;
	string stop_button_image;
	string start_button_image;
	string end_button_image;
	string set_next_button_image;
	size_t sample_rate;
	size_t frames_per_cycle;
	string tape_path;
	size_t max_tracks;
	float  smpte_frames_per_second;
	size_t over_length_short;
	size_t over_length_long;
	size_t minimum_disk_io_bytes;
	float  track_buffer_seconds;
	string default_tape;
	size_t systemic_latency;
	bool   send_midi_timecode;
	float  shuttle_speed_factor;
	float  shuttle_speed_threshold;
	size_t rf_samples;
	string ui_rcfile;
	float  meter_hold;
	int    max_level;
	int    min_level;
	string click_emphasis_sound;
	string click_sound;

	Configuration ();
	~Configuration ();

	int load_rcfile ();

  private:
	int post_parse ();
	void set_defaults ();
};

extern Configuration *Config;

#endif /* __ardour_configuration_h__ */












