/*
    Copyright (C) 1999 Paul Barton-Davis 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    $Id: click_box.cc,v 1.6 2000/05/02 02:32:42 pbd Exp $
*/

#include <stdio.h> /* for sprintf, sigh ... */
#include <gtkmmext/utils.h>
#include <gtkmmext/click_box.h>

using namespace Gtkmmext;

ClickBox::ClickBox (Gtk::Adjustment *adjp, const string &name)
	: AutoSpin (*adjp)
{
	print_func = default_printer;
	print_arg = 0;
	set_name (name);
	label.set_name (name);
	label.set_alignment (0.5, 0.5);
	add (label);
	set_events (GDK_BUTTON_RELEASE_MASK|
		    GDK_BUTTON_PRESS_MASK|
		    GDK_ENTER_NOTIFY_MASK|
		    GDK_LEAVE_NOTIFY_MASK);
	set_label ();

	get_adjustment().value_changed.connect
		(SigC::slot(this,&ClickBox::set_label));
	button_press_event.connect
		(SigC::slot((AutoSpin*)this,&AutoSpin::button_press));
	button_release_event.connect
		(SigC::slot((AutoSpin*)this,&AutoSpin::stop_spinning));
}

ClickBox::~ClickBox ()

{
}

void
ClickBox::default_printer (char buf[32], Gtk::Adjustment &adj, 
			       void *ignored)

{
	sprintf (buf, "%.2f", adj.get_value());
}

void
ClickBox::set_label ()

{
	char buf[32];

	if (print_func) {
		print_func (buf, get_adjustment(), print_arg);
		label.set_text (buf);
	}
}
